# If '.git-HEAD' is appended to the version, you are seeing an unreleased
# version of vcsh; the master branch is supposed to be clean at all times
# so you can most likely just use it nonetheless
-VERSION='1.20141009'
+VERSION='1.20141026'
SELF=$(basename $0)
fatal() {
echo "$SELF: fatal: $1" >&2
+ [ -z $2 ] && exit 1
exit $2
}
# We need to run getops as soon as possible so we catch -d and other
# options that will modify our behaviour.
# Commands are handled at the end of this script.
-while getopts "c:dvr" flag; do
+while getopts "c:dv" flag; do
if [ x"$1" = x'-d' ] || [ x"$1" = x'--debug' ]; then
set -vx
VCSH_DEBUG=1
VCSH_VERBOSE=1
echo "verbose mode on"
echo "$SELF $VERSION"
- elif [ x"$1" = x'-r' ]; then
- VCSH_OPTION_RECURSIVE=1
elif [ x"$1" = x'-c' ]; then
VCSH_OPTION_CONFIG=$OPTARG
fi
# Read defaults
: ${VCSH_REPO_D:="$XDG_CONFIG_HOME/vcsh/repo.d"}
: ${VCSH_HOOK_D:="$XDG_CONFIG_HOME/vcsh/hooks-enabled"}
+: ${VCSH_OVERLAY_D:="$XDG_CONFIG_HOME/vcsh/overlays-enabled"}
: ${VCSH_BASE:="$HOME"}
: ${VCSH_GITIGNORE:=exact}
: ${VCSH_GITATTRIBUTES:=none}
-v Enable verbose mode
commands:
- clone <remote> \\
+ clone [-b <branch>] \\
+ <remote> \\
[<repo>] Clone from an existing repository
commit Commit in all repositories
delete <repo> Delete an existing repository
help Display this help text
init <repo> Initialize a new repository
list List all repositories
- list-tracked List all files tracked by vcsh
- list-tracked-by \\
- <repo> List files tracked by a repository
+ list-tracked \\
+ [<repo>] List all files tracked all or one repositories
+ list-untracked \\
+ [<-r>] [<repo>] List all files not tracked by all or one repositories
pull Pull from all vcsh remotes
push Push to vcsh remotes
rename <repo> \\
hook pre-clone
init
git remote add origin "$GIT_REMOTE"
- git config branch.master.remote origin
- git config branch.master.merge refs/heads/master
- if [ $(git ls-remote origin master 2> /dev/null | wc -l ) -lt 1 ]; then
- info "remote is empty, not merging anything"
+ git checkout -b "$VCSH_BRANCH" || return $?
+ git config branch."$VCSH_BRANCH".remote origin
+ git config branch."$VCSH_BRANCH".merge refs/heads/"$VCSH_BRANCH"
+ if [ $(git ls-remote origin "$VCSH_BRANCH" 2> /dev/null | wc -l ) -lt 1 ]; then
+ info "remote is empty, not merging anything.
+ You should add files to your new repository."
exit
fi
- git fetch
+ git fetch origin "$VCSH_BRANCH"
hook pre-merge
- git ls-tree -r --name-only origin/master | (while read object; do
+ git ls-tree -r --name-only origin/"$VCSH_BRANCH" | (while read object; do
[ -e "$object" ] &&
error "'$object' exists." &&
VCSH_CONFLICT=1
[ x"$VCSH_CONFLICT" = x'1' ]) &&
fatal "will stop after fetching and not try to merge!
Once this situation has been resolved, run 'vcsh $VCSH_REPO_NAME pull' to finish cloning." 17
- git merge origin/master
+ git merge origin/"$VCSH_BRANCH"
hook post-merge
hook post-clone
retire
}
list_tracked() {
- for VCSH_REPO_NAME in $(list); do
- get_files
- done | sed "s,^,$(printf '%s\n' "$VCSH_BASE/" | \
- sed 's/[,\&]/\\&/g')," | sort -u
+ VCSH_REPO_NAME=$2; export VCSH_REPO_NAME
+ if [ -n "$VCSH_REPO_NAME" ]; then
+ get_files | list_tracked_helper
+ else
+ for VCSH_REPO_NAME in $(list); do
+ get_files
+ done | list_tracked_helper
+ fi
+}
+
+list_tracked_helper() {
+ sed "s,^,$(printf '%s\n' "$VCSH_BASE/" | sed 's/[,\&]/\\&/g')," | sort -u
}
list_tracked_by() {
- use
- git ls-files | sed "s,^,$(printf '%s\n' "$VCSH_BASE/" | \
- sed 's/[,\&]/\\&/g')," | sort -u
+ list_tracked $2
+}
+
+list_untracked() {
+ command -v 'comm' >/dev/null 2>&1 || fatal "Could not find 'comm'"
+
+ temp_file_others=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
+ temp_file_untracked=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
+ temp_file_untracked_copy=$(mktemp "${TMPDIR:-/tmp}/tmp.XXXXXXXXXX") || fatal 'Could not create temp file'
+
+ # Hack in support for `vcsh list-untracked -r`...
+ directory_opt="--directory"
+ shift 1
+ while getopts "r" flag; do
+ if [ x"$1" = x'-r' ]; then
+ unset directory_opt
+ fi
+ shift 1
+ done
+ # ...and parse for a potential parameter afterwards. As we shifted things out of $* in during getops, we need to look at $1
+ VCSH_REPO_NAME=$1; export VCSH_REPO_NAME
+
+ if [ -n "$VCSH_REPO_NAME" ]; then
+ list_untracked_helper $VCSH_REPO_NAME
+ else
+ for VCSH_REPO_NAME in $(list); do
+ list_untracked_helper $VCSH_REPO_NAME
+ done
+ fi
+ cat $temp_file_untracked
+
+ unset directory_opt directory_component
+ rm -f $temp_file_others $temp_file_untracked $temp_file_untracked_copy || fatal 'Could not delete temp files'
+}
+
+list_untracked_helper() {
+ export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+ git ls-files --others "$directory_opt" | (
+ while read line; do
+ echo "$line"
+ directory_component=${line%%/*}
+ [ -d "$directory_component" ] && printf '%s/\n' "$directory_component"
+ done
+ ) | sort -u > $temp_file_others
+ if [ -z "$ran_once" ]; then
+ ran_once=1
+ cp $temp_file_others $temp_file_untracked || fatal 'Could not copy temp file'
+ fi
+ cp $temp_file_untracked $temp_file_untracked_copy || fatal 'Could not copy temp file'
+ comm -12 --nocheck-order $temp_file_others $temp_file_untracked_copy > $temp_file_untracked
}
pull() {
unset VCSH_DIRECTORY
}
-command_exists() {
- command -v "$1" >/dev/null 2>&1 || fatal "Could not find '$1' command"
-}
-
-list_untracked() {
- command_exists comm
-
- temp_file_others=$(mktemp) || fatal 'Could not create temp file'
- temp_file_untracked=$(mktemp) || fatal 'Could not create temp file'
- temp_file_untracked_copy=$(mktemp) || fatal 'Could not create temp file'
-
- # create dummy git repo
- temp_repo=$(mktemp -d) || fatal 'Could not create temp repo'
-
- cd $temp_repo || fatal 'Could not cd into temp repo'
- git init -q
- mktemp -q -p $(pwd) > /dev/null || fatal 'Could not create dummy file'
- git add .
- git commit -q -m "dummy"
- cd - > /dev/null 2>&1 || fatal 'Could not cd back'
-
- [ -z "$VCSH_OPTION_RECURSIVE" ] && directory_opt="--directory"
-
- export GIT_DIR=$temp_repo/.git
- git ls-files --others "$directory_opt" | sort -u > $temp_file_untracked
-
- for VCSH_REPO_NAME in $(list); do
- export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
- git ls-files --others "$directory_opt" | (
- while read line; do
- echo "$line"
- printf '%s/\n' "$(echo "$line" | cut -d'/' -f1)"
- done
- ) | sort -u > $temp_file_others
- cp $temp_file_untracked $temp_file_untracked_copy || fatal 'Could not copy temp file'
- comm -12 --nocheck-order $temp_file_others $temp_file_untracked_copy > $temp_file_untracked
- done
- cat $temp_file_untracked
-
- unset directory_opt
- rm -f $temp_file_others $temp_file_untracked $temp_file_untracked_copy || fatal 'Could not delete temp files'
- rm -rf $temp_repo || fatal 'Could not delete temp repo'
-}
-
rename() {
git_dir_exists
[ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
status() {
if [ -n "$VCSH_REPO_NAME" ]; then
- GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
- use
- git status --short --untracked-files='no'
- VCSH_COMMAND_RETURN_CODE=$?
+ status_helper $VCSH_REPO_NAME
else
for VCSH_REPO_NAME in $(list); do
echo "$VCSH_REPO_NAME:"
- GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
- use
- git status --short --untracked-files='no'
- VCSH_COMMAND_RETURN_CODE=$?
+ status_helper $VCSH_REPO_NAME
echo
done
fi
}
+status_helper() {
+ GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
+ use
+ remote_tracking_branch=$(git rev-parse --abbrev-ref --symbolic-full-name @{u} 2> /dev/null) && {
+ commits_behind=$(git log ..${remote_tracking_branch} --oneline | wc -l)
+ commits_ahead=$(git log ${remote_tracking_branch}.. --oneline | wc -l)
+ [ ${commits_behind} -ne 0 ] && echo "Behind $remote_tracking_branch by $commits_behind commits"
+ [ ${commits_ahead} -ne 0 ] && echo "Ahead of $remote_tracking_branch by $commits_ahead commits"
+ }
+ git status --short --untracked-files='no'
+ VCSH_COMMAND_RETURN_CODE=$?
+}
+
upgrade() {
hook pre-upgrade
# fake-bare repositories are not bare, actually. Set this to false
}
which() {
+ [ -e "$VCSH_COMMAND_PARAMETER" ] || fatal "'$VCSH_COMMAND_PARAMETER' does not exist" 1
for VCSH_REPO_NAME in $(list); do
for VCSH_FILE in $(get_files); do
echo "$VCSH_FILE" | grep -q "$VCSH_COMMAND_PARAMETER" && echo "$VCSH_REPO_NAME: $VCSH_FILE"
esac
if [ x"$VCSH_COMMAND" = x'clone' ]; then
+ VCSH_BRANCH=
+ if [ "$2" = -b ]; then
+ VCSH_BRANCH=$3
+ shift
+ shift
+ fi
[ -z "$2" ] && fatal "$VCSH_COMMAND: please specify a remote" 1
GIT_REMOTE="$2"
- [ -n "$3" ] && VCSH_REPO_NAME=$3 || VCSH_REPO_NAME=$(basename "${GIT_REMOTE#*:}" .git)
+ [ -n "$VCSH_BRANCH" ] || if [ "$3" = -b ]; then
+ VCSH_BRANCH=$4
+ shift
+ shift
+ fi
+ if [ -n "$3" ]; then
+ VCSH_REPO_NAME=$3
+ [ -z "$VCSH_BRANCH" ] && [ "$4" = -b ] && VCSH_BRANCH=$5
+ else
+ VCSH_REPO_NAME=$(basename "${GIT_REMOTE#*:}" .git)
+ fi
[ -z "$VCSH_REPO_NAME" ] && fatal "$VCSH_COMMAND: could not determine repository name" 1
export VCSH_REPO_NAME
+ [ -n "$VCSH_BRANCH" ] || VCSH_BRANCH=master
GIT_DIR=$VCSH_REPO_D/$VCSH_REPO_NAME.git; export GIT_DIR
elif [ "$VCSH_COMMAND" = 'version' ]; then
echo "$SELF $VERSION"
verbose "$VCSH_COMMAND begin"
VCSH_COMMAND=$(echo "$VCSH_COMMAND" | sed 's/-/_/g'); export VCSH_COMMAND
+
+# Source repo-specific configuration file
+[ -r "$XDG_CONFIG_HOME/vcsh/config.d/$VCSH_REPO_NAME" ] && . "$XDG_CONFIG_HOME/vcsh/config.d/$VCSH_REPO_NAME"
+
+# source overlay functions
+for overlay in "$VCSH_OVERLAY_D/$VCSH_COMMAND"* "$VCSH_OVERLAY_D/$VCSH_REPO_NAME.$VCSH_COMMAND"*; do
+ [ -r "$overlay" ] || continue
+ info "sourcing '$overlay'"
+ . "$overlay"
+done
+
hook pre-command
$VCSH_COMMAND "$@"
hook post-command